#include "arch/Serial.h"
#include "arch/CPU.h"
#include <luna/Format.h>

namespace Serial
{
    void write(const char* str, usize size)
    {
        while (size--) putchar(*str++);
    }

    void print(const char* str)
    {
        while (*str) putchar(*str++);
    }

    void println(const char* str)
    {
        print(str);
        putchar('\n');
    }

    Result<usize> printf(const char* format, ...)
    {
        va_list ap;
        va_start(ap, format);
        auto rc = cstyle_format(
            format,
            [](char c, void*) -> Result<void> {
                putchar(c);
                return {};
            },
            nullptr, ap);
        va_end(ap);
        return rc;
    }
}